<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
        <el-form-item label="漫画ID">
          {{bookId}}
        </el-form-item>
        <el-form-item label="漫画名称">
          {{bookName}}
        </el-form-item>
        <el-form-item label="作者">
          {{author}}
        </el-form-item>
      </el-form>
    </div>

    <el-table :data="tableData" style="width:100%"
              @selection-change="handleSelectionChange"
              @sort-change="changeSort"
              :default-sort="{prop: 'sort', order: 'descending'}"
              class="show_table" >
      <el-table-column label="免费" width="80" align="center">
        <template slot-scope="scope">
            <el-checkbox :checked="scope.row.charge<0" :disabled="true"></el-checkbox>
        </template>
      </el-table-column>
      <el-table-column label="漫画ID" width="80" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.bookId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="章节顺序" width="80" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.episode }}</span>
        </template>
      </el-table-column>
      <el-table-column label="章节标题" width="300" :show-overflow-tooltip="true" align="left">
        <template slot-scope="scope">
          <span>{{ scope.row.title }}</span>
        </template>
      </el-table-column>
      <el-table-column label="图片数" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.imageCount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" width="180" align="center" prop="createdAt" sortable="custom" :sort-by="['createdAt']">
        <template slot-scope="scope">
          <span>{{ scope.row.createdAt }}</span>
        </template>
      </el-table-column>
      <el-table-column label="更新时间" width="180" align="center" prop="updatedAt" sortable="custom" :sort-by="['updatedAt']">
        <template slot-scope="scope">
          <span>{{ scope.row.updatedAt }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" min-width="100" fixed="right" align="center">
        <template slot-scope="scope">
          <el-button @click="handleView(scope.row)" type="primary" size="small">查看漫画</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>


    <el-dialog :title="title" :visible.sync="dialogVisible" width="60%" :before-close="handleClose">
      <li v-for="(item, index) in this.showRow.imageUrls">
        <h4>{{showRow.title}}&nbsp;&nbsp;{{index+1}}/{{showRow.imageCount}}</h4>
        <br>
        <el-image class="showimg"
                  :src="item"
                  style="cursor:pointer"
                  fit="fit"
        />
        <br>
      </li>
    </el-dialog>
  </div>

</template>




<script>
import {
  getChapterList,
} from "@/api/booksChapter";

export default {
  data() {
    return {

      queryParams:{//查询参数
        bookId: "",
      },
      bookName:"",
      author:"",
      bookId: "",
      showRow: {
        title: null,
        imageCount: null,
        imageUrls:null,
      },
      multipleSelection: [], //多选，用于批量删除
      tableData: [],
      currentPage: 1,
      pageSize: 40,
      total: 0, //总数量
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
      dialogVisible: false,
    };
  },
  created() {
    this.chapterList();
  },
  methods: {

    changeSort (val) {
      // 根据当前排序重新获取后台数据,一般后台会需要一个排序的参数
      if(val.order == "ascending") {
        this.orderByAscColumn = val.prop
        this.orderByDescColumn = ""
      } else {
        this.orderByAscColumn = ""
        this.orderByDescColumn = val.prop
      }
      this.booksList()
    },

    chapterList: function() {
      console.log(this.$route.query.bookId);
      this.bookId = this.$route.query.bookId;
      this.bookName = this.$route.query.bookName;
      this.author = this.$route.query.author;
      this.queryParams.bookId=this.bookId;
      this.queryParams.currentPage = this.currentPage;
      this.queryParams.pageSize = this.pageSize;
      this.queryParams.orderByDescColumn = this.orderByDescColumn
      this.queryParams.orderByAscColumn = this.orderByAscColumn
      getChapterList(this.queryParams).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    handleView: function(row) {
      console.log(row);
      this.dialogVisible = true;
      this.showRow = row;
    },
    handleClose(){
      this.showRow = {};
      this.dialogVisible = false;
    },
    handleFind: function() {
      this.currentPage = 1
      this.chapterList();
    },
    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.chapterList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.chapterList();
    },

    // 改变多选
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },

  }
};
</script>
<style scoped>
  .el-form-item {
    margin-bottom: 10px;
  }
</style>
